config_acceptable([X,Y,Z,T]) :- fd_domain(X,0,1), fd_domain(Y,0,3), fd_domain(Z,0,5), fd_domain(T,0,7).

successeur([X,Y,Z,T],[XX,YY,ZZ,TT]) :- config_acceptable([X,Y,Z,T]), config_acceptable([XX,YY,ZZ,TT]),
X #< XX, Y #= YY, Z #= ZZ, T #= TT.
successeur([X,Y,Z,T],[XX,YY,ZZ,TT]) :- config_acceptable([X,Y,Z,T]), config_acceptable([XX,YY,ZZ,TT]),
X #= XX, Y #< YY, Z #= ZZ, T #= TT.
successeur([X,Y,Z,T],[XX,YY,ZZ,TT]) :- config_acceptable([X,Y,Z,T]), config_acceptable([XX,YY,ZZ,TT]),
X #= XX, Y #= YY, Z #< ZZ, T #= TT.
successeur([X,Y,Z,T],[XX,YY,ZZ,TT]) :- config_acceptable([X,Y,Z,T]), config_acceptable([XX,YY,ZZ,TT]),
X #= XX, Y #= YY, Z #= ZZ, T #< TT.

non(X) :- X, !, fail.
non(_).

pas_de_config_perdante_0([],_,_).
pas_de_config_perdante_0([Cfg|_],_,Perd) :- member([Cfg,0],Perd), !, fail.
pas_de_config_perdante_0([Cfg|Liste],Gagn,Perd) :- member([Cfg,0],Gagn), pas_de_config_perdante_0(Liste,Gagn,Perd).

% pas_de_config_gagnante_0([],_,_).
% pas_de_config_gagnante_0([Cfg|_],Gagn,_) :- member(Cfg,Gagn), !, fail.
% pas_de_config_gagnante_0([Cfg|Liste],Gagn,Perd) :- config_perdante_0(Cfg,1,Gagn,Perd), pas_de_config_gagnante_0(Liste,Gagn,Perd).

config_gagnante_0(LL,0,_,_) :- successeur([0,0,0,0],LL).
config_gagnante_0(LL,0,Gagn,_) :- successeur(L,LL), member([L,1],Gagn).
config_gagnante_0(LL,1,Gagn,Perd) :- findall(L,(successeur(L,LL),fd_labeling(L)),Liste),
 pas_de_config_perdante_0(Liste,Gagn,Perd).

% config_perdante_0([0,0,0,0],0,_,_).
% config_perdante_0(LL,1,Gagn,Perd) :- successeur(L,LL), config_perdante_0(L,0,Gagn,Perd).
% config_perdante_0(LL,0,Gagn,Perd) :- findall(L,(successeur(L,LL),fd_labeling(L)),Liste),
% pas_de_config_gagnante_0(Liste,Gagn,Perd).

resout(L) :- config_gagnante_0(L,0), fd_labeling(L).

suivant([X,Y,Z,T],[X,Y,Z,TT]) :- T #< 7, TT #= T+1.
suivant([X,Y,Z,7],[X,Y,ZZ,0]) :- Z #< 5, ZZ #= Z+1.
suivant([X,Y,5,7],[X,YY,0,0]) :- Y #< 3, YY #= Y+1.
suivant([0,3,5,7],[1,0,0,0]).

resout_tout([X,Y,Z,T],0,Gagn,Perd) :- config_gagnante_0([X,Y,Z,T],0,Gagn,Perd),
write('Configuration gagnante : '), write(X), write(' '), write(Y), write(' '), write(Z), write(' '), write(T), write(' ---- joueur 0'), nl,
!, resout_tout([X,Y,Z,T],1,[[[X,Y,Z,T],0]|Gagn],Perd).

resout_tout([X,Y,Z,T],0,Gagn,Perd) :- % config_perdante_0([X,Y,Z,T],0,Gagn,Perd),
resout_tout([X,Y,Z,T],1,Gagn,[[[X,Y,Z,T],0]|Perd]).

resout_tout([1,3,5,7],1,Gagn,Perd) :- config_gagnante_0([1,3,5,7],1,Gagn,Perd), write('Configuration gagnante : 1 3 5 7 ---- joueur 1').
resout_tout([X,Y,Z,T],1,Gagn,Perd) :- config_gagnante_0([X,Y,Z,T],1,Gagn,Perd),
write('Configuration gagnante : '), write(X), write(' '), write(Y), write(' '), write(Z), write(' '), write(T), write(' ---- joueur 1'), nl,
suivant([X,Y,Z,T],[XX,YY,ZZ,TT]), !, resout_tout([XX,YY,ZZ,TT],0,[[[X,Y,Z,T],1]|Gagn],Perd).

resout_tout([X,Y,Z,T],1,Gagn,Perd) :- % config_perdante_0([X,Y,Z,T],0,Gagn,Perd),
suivant([X,Y,Z,T],[XX,YY,ZZ,TT]), resout_tout([XX,YY,ZZ,TT],0,Gagn,[[[X,Y,Z,T],1]|Perd]).


resolution :- resout_tout([0,0,0,0],0,[],[]).
