num(1,[X|_],X).
num(N,[_|L],X) :- N #> 1, num(NN,L,X), NN #= N-1.

contrainte_1(X1,_,_,_,_) :- X1 #= 1, X1 #= 2.
contrainte_1(X1,X2,_,_,_) :- X1 #= 2, X1 #\= 2, X2 #= 2.
contrainte_1(X1,X2,X3,_,_) :- X1 #= 3, X1 #\= 2, X2 #\= 2, X3 #= 2.
contrainte_1(X1,X2,X3,X4,_) :- X1 #= 4, X1 #\= 2, X2 #\= 2, X3 #\= 2, X4 #= 2.
contrainte_1(X1,X2,X3,X4,X5) :- X1 #= 5, X1 #\= 2, X2 #\= 2, X3 #\= 2, X4 #\= 2, X5 #= 2.

occ_cons_egal([_],0).
occ_cons_egal([X,X|L],N) :- occ_cons_egal([X|L],NN), NN #= N-1.
occ_cons_egal([Y,X|L],N) :- X #\= Y, occ_cons_egal([X|L],N).

contrainte_2(Rep) :- num(2,Rep,X2), X2 #= 1, num(6,Rep,X6), num(7,Rep,X7), X6 #= X7, occ_cons_egal(Rep,1).
contrainte_2(Rep) :- num(2,Rep,X2), X2 #= 2, num(7,Rep,X7), num(8,Rep,X8), X7 #= X8, occ_cons_egal(Rep,1).
contrainte_2(Rep) :- num(2,Rep,X2), X2 #= 3, num(8,Rep,X8), num(9,Rep,X9), X8 #= X9, occ_cons_egal(Rep,1).
contrainte_2(Rep) :- num(2,Rep,X2), X2 #= 4, num(9,Rep,X9), num(10,Rep,X10), X9 #= X10, occ_cons_egal(Rep,1).
contrainte_2(Rep) :- num(2,Rep,X2), X2 #= 5, num(10,Rep,X10), num(11,Rep,X11), X10 #= X11, occ_cons_egal(Rep,1).

nb(_,[],0).
nb(X,[X|L],N) :- nb(X,L,NN), NN #= N-1.
nb(X,[Y|L],N) :- X #\= Y, nb(X,L,N).

contrainte_3(Rep) :- num(3,Rep,X3), X3 #= 1, nb(5,Rep,0).
contrainte_3(Rep) :- num(3,Rep,X3), X3 #= 2, nb(5,Rep,1).
contrainte_3(Rep) :- num(3,Rep,X3), X3 #= 3, nb(5,Rep,2).
contrainte_3(Rep) :- num(3,Rep,X3), X3 #= 4, nb(5,Rep,3).
contrainte_3(Rep) :- num(3,Rep,X3), X3 #= 5, nb(5,Rep,4).

contrainte_4(Rep) :- num(4,Rep,X4), X4 #= 1, nb(1,Rep,4).
contrainte_4(Rep) :- num(4,Rep,X4), X4 #= 2, nb(1,Rep,5).
contrainte_4(Rep) :- num(4,Rep,X4), X4 #= 3, nb(1,Rep,6).
contrainte_4(Rep) :- num(4,Rep,X4), X4 #= 4, nb(1,Rep,7).
contrainte_4(Rep) :- num(4,Rep,X4), X4 #= 5, nb(1,Rep,8).

contrainte_5(X1,X2,X3,X4,X5) :- X5 #= 1, X1 #= X5, X2 #\= X5, X3 #\= X5, X4 #\= X5, X5 #\= X5.
contrainte_5(X1,X2,X3,X4,X5) :- X5 #= 2, X2 #= X5, X1 #\= X5, X3 #\= X5, X4 #\= X5, X5 #\= X5.
contrainte_5(X1,X2,X3,X4,X5) :- X5 #= 3, X3 #= X5, X1 #\= X5, X2 #\= X5, X4 #\= X5, X5 #\= X5.
contrainte_5(X1,X2,X3,X4,X5) :- X5 #= 4, X4 #= X5, X1 #\= X5, X2 #\= X5, X3 #\= X5, X5 #\= X5.
contrainte_5(X1,X2,X3,X4,X5) :- X5 #= 5, X5 #= X5, X1 #\= X5, X2 #\= X5, X3 #\= X5, X4 #\= X5.

contrainte_6(X6,X17) :- X6 #= 1, X17 #= 3.
contrainte_6(X6,X17) :- X6 #= 2, X17 #= 4.
contrainte_6(X6,X17) :- X6 #= 3, X17 #= 5.
contrainte_6(X6,X17) :- X6 #= 4, X17 #\= 3, X17 #\= 4, X17 #\= 5.
contrainte_6(X6,X17) :- X6 #= 5, X17 #= 3, X17 #= 4, X17 #= 5, X17 #\= 3, X17 #\= 4, X17 #\= 5. % peut-être pas comme ça

contrainte_7(X7,X8) :- X7 #= 1, (X8 #= X7 + 4 ; X7 #= X8 + 4).
contrainte_7(X7,X8) :- X7 #= 2, (X8 #= X7 + 3 ; X7 #= X8 + 3).
contrainte_7(X7,X8) :- X7 #= 3, (X8 #= X7 + 2 ; X7 #= X8 + 2).
contrainte_7(X7,X8) :- X7 #= 4, (X8 #= X7 + 1 ; X7 #= X8 + 1).
contrainte_7(X7,X8) :- X7 #= 5, X8 #= X7.

contrainte_8(Rep) :- num(8,Rep,X8), X8 #= 1, nb(1,Rep,N1), nb(5,Rep,N5), N1 + N5 #= 4.
contrainte_8(Rep) :- num(8,Rep,X8), X8 #= 2, nb(1,Rep,N1), nb(5,Rep,N5), N1 + N5 #= 5.
contrainte_8(Rep) :- num(8,Rep,X8), X8 #= 3, nb(1,Rep,N1), nb(5,Rep,N5), N1 + N5 #= 6.
contrainte_8(Rep) :- num(8,Rep,X8), X8 #= 4, nb(1,Rep,N1), nb(5,Rep,N5), N1 + N5 #= 7.
contrainte_8(Rep) :- num(8,Rep,X8), X8 #= 5, nb(1,Rep,N1), nb(5,Rep,N5), N1 + N5 #= 8.

contrainte_9(X9,X10,_,_,_,_) :- X9 #= 1, X10 #= 1.
contrainte_9(X9,X10,X11,_,_,_) :- X9 #= 2, X10 #\= 2, X11 #= 2.
contrainte_9(X9,X10,X11,X12,_,_) :- X9 #= 3, X10 #\= 3, X11 #\= 3, X12 #= 3.
contrainte_9(X9,X10,X11,X12,X13,_) :- X9 #= 4, X10 #\= 4, X11 #\= 4, X12 #\= 4, X13 #= 4.
contrainte_9(X9,X10,X11,X12,X13,X14) :- X9 #= 5, X10 #\= 5, X11 #\= 5, X12 #\= 5, X13 #\= 5, X14 #= 5.

contrainte_10(X10,X16) :- X10 #= 1, X16 #= 4.
contrainte_10(X10,X16) :- X10 #= 2, X16 #= 1.
contrainte_10(X10,X16) :- X10 #= 3, X16 #= 5.
contrainte_10(X10,X16) :- X10 #= 4, X16 #= 2.
contrainte_10(X10,X16) :- X10 #= 5, X16 #= 3.

contrainte_11(X11,Rep10) :- X11 #= 1, nb(2,Rep10,0).
contrainte_11(X11,Rep10) :- X11 #= 2, nb(2,Rep10,1).
contrainte_11(X11,Rep10) :- X11 #= 3, nb(2,Rep10,2).
contrainte_11(X11,Rep10) :- X11 #= 4, nb(2,Rep10,3).
contrainte_11(X11,Rep10) :- X11 #= 5, nb(2,Rep10,4).

pair(N) :- N #= 2 * _.
impair(N) :- N #= 2 * _ + 1.
carre(N) :- N #= X * X.
premier(2). % trichons un peu
premier(3).
premier(5).
premier(7).
premier(11).
premier(13).
premier(17).
premier(19).
divpar5(N) :- N #= 5 * _.

contrainte_12(Rep) :- num(12,Rep,X12), X12 #= 1, nb(2,Rep,N2), nb(3,Rep,N3), nb(4,Rep,N4), N #= N2 + N3 + N4, pair(N).
contrainte_12(Rep) :- num(12,Rep,X12), X12 #= 2, nb(2,Rep,N2), nb(3,Rep,N3), nb(4,Rep,N4), N #= N2 + N3 + N4, impair(N).
contrainte_12(Rep) :- num(12,Rep,X12), X12 #= 3, nb(2,Rep,N2), nb(3,Rep,N3), nb(4,Rep,N4), N #= N2 + N3 + N4, carre(N).
contrainte_12(Rep) :- num(12,Rep,X12), X12 #= 4, nb(2,Rep,N2), nb(3,Rep,N3), nb(4,Rep,N4), N #= N2 + N3 + N4, premier(N).
contrainte_12(Rep) :- num(12,Rep,X12), X12 #= 5, nb(2,Rep,N2), nb(3,Rep,N3), nb(4,Rep,N4), N #= N2 + N3 + N4, divpar5(N).

contrainte_13(Repimp) :- num(7,Repimp,X13), X13 #= 1, nb(1,Repimp,1), num(5,Repimp,1).
contrainte_13(Repimp) :- num(7,Repimp,X13), X13 #= 2, nb(1,Repimp,1), num(6,Repimp,1).
contrainte_13(Repimp) :- num(7,Repimp,X13), X13 #= 3, nb(1,Repimp,1), num(7,Repimp,1).
contrainte_13(Repimp) :- num(7,Repimp,X13), X13 #= 4, nb(1,Repimp,1), num(8,Repimp,1).
contrainte_13(Repimp) :- num(7,Repimp,X13), X13 #= 5, nb(1,Repimp,1), num(9,Repimp,1).

contrainte_14(Rep) :- num(14,Rep,X14), X14 #= 1, nb(4,Rep,6).
contrainte_14(Rep) :- num(14,Rep,X14), X14 #= 2, nb(4,Rep,7).
contrainte_14(Rep) :- num(14,Rep,X14), X14 #= 3, nb(4,Rep,8).
contrainte_14(Rep) :- num(14,Rep,X14), X14 #= 4, nb(4,Rep,9).
contrainte_14(Rep) :- num(14,Rep,X14), X14 #= 5, nb(4,Rep,10).

contrainte_15(X15,X12) :- X15 #= X12. % gain de temps

contrainte_16(X16,X10) :- X16 #= 1, X10 #= 4.
contrainte_16(X16,X10) :- X16 #= 2, X10 #= 3.
contrainte_16(X16,X10) :- X16 #= 3, X10 #= 2.
contrainte_16(X16,X10) :- X16 #= 4, X10 #= 1.
contrainte_16(X16,X10) :- X16 #= 5, X10 #= 5.

contrainte_17(X17,X6) :- contrainte_6(X17,X6). % gain de temps aussi

contrainte_18(Rep) :- num(18,Rep,X18), X18 #= 1, nb(1,Rep,N1), nb(2,Rep,N2), N1 #= N2.
contrainte_18(Rep) :- num(18,Rep,X18), X18 #= 2, nb(1,Rep,N1), nb(3,Rep,N3), N1 #= N3.
contrainte_18(Rep) :- num(18,Rep,X18), X18 #= 3, nb(1,Rep,N1), nb(4,Rep,N4), N1 #= N4.
contrainte_18(Rep) :- num(18,Rep,X18), X18 #= 4, nb(1,Rep,N1), nb(5,Rep,N5), N1 #= N5.
contrainte_18(Rep) :- num(18,Rep,X18), X18 #= 5, nb(1,Rep,N1), nb(2,Rep,N2), N1 #\= N2, nb(3,Rep,N3), N1 #\= N3, nb(4,Rep,N4), N1 #\= N4, nb(5,Rep,N5), N1 #\= N5.

contrainte_19(X19) :- X19 #= X19. % une dernière fois

% contrainte_20(X20) :- X20 #= 5.
contrainte_20(_) :- true.

solve(Reponses) :-
Reponses = [X1,X2,X3,X4,X5,X6,X7,X8,X9,X10,X11,X12,X13,X14,X15,X16,X17,_,X19,X20],
fd_domain(Reponses,1,5),
contrainte_1(X1,X2,X3,X4,X5),
contrainte_2(Reponses),
contrainte_3(Reponses),
contrainte_4(Reponses),
contrainte_5(X1,X2,X3,X4,X5),
contrainte_6(X6,X17),
contrainte_7(X7,X8),
contrainte_8(Reponses),
contrainte_9(X9,X10,X11,X12,X13,X14),
contrainte_10(X10,X16),
contrainte_11(X11,[X1,X2,X3,X4,X5,X6,X7,X8,X9,X10]),
contrainte_12(Reponses),
contrainte_13([X1,X3,X5,X7,X9,X11,X13,X15,X17,X19]),
contrainte_14(Reponses),
contrainte_15(X15,X12),
contrainte_16(X16,X10),
contrainte_17(X17,X6),
contrainte_18(Reponses),
contrainte_19(X19),
contrainte_20(X20),
fd_labeling(Reponses).

solve_ordre_optimise(Reponses) :-
Reponses = [X1,X2,X3,X4,X5,X6,X7,X8,X9,X10,X11,X12,X13,X14,X15,X16,X17,_,X19,X20],
fd_domain(Reponses,1,5),
contrainte_20(X20),
contrainte_5(X1,X2,X3,X4,X5),
contrainte_10(X10,X16),
contrainte_16(X16,X10),
contrainte_6(X6,X17),
contrainte_17(X17,X6),
contrainte_2(Reponses),
contrainte_13([X1,X3,X5,X7,X9,X11,X13,X15,X17,X19]),
contrainte_1(X1,X2,X3,X4,X5),
contrainte_11(X11,[X1,X2,X3,X4,X5,X6,X7,X8,X9,X10]),
contrainte_9(X9,X10,X11,X12,X13,X14),
contrainte_7(X7,X8),
contrainte_8(Reponses),
contrainte_3(Reponses),
contrainte_4(Reponses),
contrainte_12(Reponses),
contrainte_18(Reponses),
contrainte_14(Reponses),
contrainte_15(X15,X12),
contrainte_19(X19),
fd_labeling(Reponses).
